package fr.cnam.etrevivant;

import fr.cnam.multiagent.*;

// Classe de dfinition d'un Humain.
// Un humain meurt ds que on tente de le tuer.
// 
// La classe hrite de la classe EtreVivant qui implmente une partie
//   de l'interface Agent. Elle doit donc implmenter le reste de l'interface
//
public class Humain extends EtreVivant
{
    private boolean vivant;  // True si vivant sinon false

    // Constructeur
    public Humain(String nom)
    {
        super(nom);
        genre = "Humain";
        this.vivant = true;
    }

    // ========== Implmentation de l'interface Agent
    // ======================================================
    
    // Humain est vivant s'il n'a pas t tu
    public boolean estVivant()
    {
        return this.vivant;
    }

    // Un humain a 1 vie s'il est vivant)
    public int nbVies()
    {
        if (this.vivant) return 1;
        else return 0;
    }

    // Tuer un humain 
    public void tuer()
    {
        this.vivant=false;
    }

    // Ressusciter un humain
    public void ressusciter()
    {
        this.vivant = true;
    }
}